!
! >>> Include file for hw95_out. Defined the input file and output files.
!
!     HW95_OUT   27-JUN-1997   (c)  L. Petrov  12-JUL-2002 15:37:50
!
!     HW_FILE    -- name of the original file with Hartmann-Wenzell tidal
!                   expansion
!     HW1_OUTFIL -- name of the output file. Tidal constituents are
!                   in the same order as they were in HW95
!     HW2_OUTFIL -- name of the output file. Tidal constituents are sorted
!                   in decreasing their amplitudes
!     HW3_OUTFIL -- name of the output file. Tidal constituents are sorted
!                   in decreasing their amplitudes. This file is in the
!                   format suitable for using in the include blocks for
!                   f77 or  f90 source code
!     HW_INC_FORMAT -- the format of the HW3_OUTFIL file. Acceptable values:
!                      f77 and f90 .
!
      CHARACTER  HW_FILE*64, HW1_OUTFIL*64, HW2_OUTFIL*64, HW3_OUTFIL*64
      CHARACTER  HW_INC_FORMAT*3
      DATA   HW_FILE &
     & / '/home/lpetrov/data/HW95.DAT                                     ' /
!
      DATA   HW1_OUTFIL &
     & / '/tmp/hw95_unsorted.waves                                        ' /
!
      DATA   HW2_OUTFIL &
     & / '/tmp/hw95_sorted.waves                                          ' /
!
      DATA   HW3_OUTFIL &
     & / '/tmp/hw95_norm.i                                                ' /
!
      DATA   HW_INC_FORMAT  &
     & / 'f90' /
!
! --- Set the frequency resolution. HW95_OUT will try to convert mixed terms
! --- C1*t * cos ( Omega*t + Phi ) in C2 * COS ( Omega1 -+ Freq_Res)*t + ... )
! --- where Freq_Res is (a small) frequency. If you do not want this conversion,
! --- then set FREQ_RES to 1.0D0
!
      REAL*8     FREQ_RES
      PARAMETER ( FREQ_RES = 1.069696236521D-08 ) ! Freq. for 18.6 years period
