      FUNCTION ILEN ( STR )
! ************************************************************************
! *                                                                      *
! *   Function  ILEN  returns position of the last character of the      *
! *   string STR whcih is not blank or binary zero.                      *
! *                                                                      *
! *  ### 17-JAN-1989     ILEN      v1.0 (c)  L. Petrov  12-JUL-2002 ###  *
! *                                                                      *
! ************************************************************************
      CHARACTER STR*(*)
      ILEN=0
      DO 410 J1=LEN(STR),1,-1
         ILEN=J1
         IF ( STR(J1:J1) .NE. ' '  .AND.  STR(J1:J1) .NE. CHAR(0) ) RETURN
 410  CONTINUE
      ILEN=0
      RETURN
      END  !#!  ILEN  #!#
!
! ------------------------------------------------------------------------
!
      FUNCTION I_LEN ( STR )
! ************************************************************************
! *                                                                      *
! *   Function  ILEN  returns position of the last character of the      *
! *   string STR which is not blank or binary zero. If the line is       *
! *   empty, i.e.  contains only blanks and/or binary zeros, then I_LEN  *
! *   returns 1.                                                         *
! *                                                                      *
! *  ### 17-JAN-1989    I_LEN      v1.0 (c)  L. Petrov  12-JUL-2002 ###  *
! *                                                                      *
! ************************************************************************
      CHARACTER STR*(*)
      I_LEN=1
      DO 410 J1=LEN(STR),1,-1
         I_LEN=J1
         IF ( STR(J1:J1) .NE. ' '  .AND.  STR(J1:J1) .NE. CHAR(0) ) RETURN
 410  CONTINUE
      I_LEN=1
      RETURN
      END  !#!  I_LEN  #!#
!
! ------------------------------------------------------------------------
!
      SUBROUTINE CLRCH ( STR )
! ************************************************************************
! *                                                                      *
! *   Routine  CLRCH fills the string STR with blanks.                   *
! *                                                                      *
! *  ###  17-JAN-1989     CLRCH    v1.0 (c)  L. Petrov  12-JUL-2002 ###  *
! *                                                                      *
! ************************************************************************
      CHARACTER  STR*(*)
      DO 410 J1=1,LEN(STR)
         STR(J1:J1)=' '
 410  CONTINUE
      RETURN
      END  !#!  CLRCH  #!#
!
! ------------------------------------------------------------------------
!
        FUNCTION LINDEX ( STR, SUBSTR )
! ************************************************************************
! *                                                                      *
! *     Routine  LINDEX  eximines string STR and search for the          *
! *   substring SUBSTR there. If the sustring is encountered more than   *
! *   omce in the string STR than it locates the LAST appearence of the  *
! *   sustring. It returns the index of the symbol in the string STR     *
! *   where the sustring is found. It works analogouly to the built-in   *
! *   finction of INDEX but detects the last appearance of the substring.*
! *   It returns 0 if the substring has not been found.                  *
! *                                                                      *
! *     Examples:                                                        *
! *                                                                      *
! *     STR=DOGCATFISHCAT       SUBSTR=CAT      INDEX=4   LINDEX=11      *
! *     STR=DOGCATFISHCAT       SUBSTR=FISH     INDEX=7   LINDEX=7       *
! *     STR=DOGCATFISHCAT       SUBSTR=BIRD     INDEX=0   LINDEX=0       *
! *                                                                      *
! * _________________________ Input parameters: ________________________ *
! *                                                                      *
! *      STR ( CHARACTER ) -- String under investigation.                *
! *   SUBSTR ( CHARACTER ) -- Substring which is sought.                 *
! *                                                                      *
! * _________________________ Output parameters: _______________________ *
! *                                                                      *
! * <LINDEX> ( INTEGER*4 ) -- position of the last occurrence of the     *
! *                           substring SUBSTR. If SUBSTR is not found   *
! *                           then LINDEX = 0                            *
! *                                                                      *
! *  ### 17-JAN-1989      LINDEX    v1.0 (c) L. Petrov  12-JUL-2002 ###  *
! *                                                                      *
! ************************************************************************
        CHARACTER STR*(*), SUBSTR*(*)
        L=LEN(STR)
        LINDEX=0
        KC=1
        DO 410 J1=1,L
           KC=INDEX ( STR( (LINDEX+1):L ), SUBSTR )
           IF(KC.EQ.0) GOTO 810
           LINDEX=LINDEX+KC
           IF( LINDEX.GE.L ) GOTO 810
  410   CONTINUE
  810   RETURN
        END  !#!  LINDEX  #!#
!
! ------------------------------------------------------------------------
!
      SUBROUTINE COPY_V ( N, VEC1, VEC2 )
! ************************************************************************
! *                                                                      *
! *   Subroutine  COPY_V  copies N elements of the vector VEC1 to the    *
! *   vector  VEC2                                                       *
! *                                                                      *
! *  ###  12-DEC-1996   COPY_V     v1.0  (c)  L. Petrov  12-Dec-96  ###  *
! *                                                                      *
! ************************************************************************
      INTEGER*4  N
      REAL*8     VEC1(N), VEC2(N)
      IF ( N .GT. 0 ) THEN
!!         CALL VEC_$DCOPY ( VEC1, VEC2, N )
           DO 410 J1=1,N
              VEC2(J1) = VEC1(J1)
 410       CONTINUE
      END IF
      RETURN
      END  !#!  COPY_V  #!#
!
! ------------------------------------------------------------------------
!
      SUBROUTINE SOTID_NOUT_R8 ( N, VEC )
! ************************************************************************
! *                                                                      *
! *   Subroutine  NOUT_R8  fills N elements of the vector VEC by zeroes. *
! *                                                                      *
! *  ###  12-Dec-96     NOUT_R8    v1.0  (c)  L. Petrov  12-Dec-96  ###  *
! *                                                                      *
! ************************************************************************
      INTEGER*4  N
      REAL*8     VEC(N)
      IF ( N .GT. 0 ) THEN
!!           CALL VEC_$DINIT ( VEC, N, 0.0D0 )
           DO 410 J1=1,N
              VEC(J1) = 0.0D0
 410       CONTINUE
      END IF
      RETURN
      END  SUBROUTINE  SOTID_NOUT_R8
!
! ------------------------------------------------------------------------
!
        SUBROUTINE CHASHL ( STR )
! ************************************************************************
! *                                                                      *
! *   Routine   CHASHL  adjusts string STR at the left edge. Thus,       *
! *   the first symbol of the string STR becomes the symbol which is not *
! *   a blank or a binary zero. Freed symbols at the right edge are      *
! *   replaced by blanks.                                                *
! *                                                                      *
! *  ###  21-DEC-90      CHASHL    v1.0  (c)  L. Petrov  21-DEC-90  ###  *
! *                                                                      *
! ************************************************************************
        CHARACTER STR*(*)
        INTEGER*4, EXTERNAL :: ILEN
!
        LN=LEN(STR)
!
! ----- Search for the fist non-blankl symbol
!
        DO 410 J1=1,LN
           IF ( STR(J1:J1) .NE. ' '  .AND.  STR(J1:J1) .NE. CHAR(0) ) THEN
                IB=J1
                GOTO 810
           END IF
 410    CONTINUE
        RETURN
!
 810    CONTINUE
        IF ( IB .EQ. 1 ) RETURN
!
! ----- Shift IB-1 sybols to the left
!
        STR(1:LN-(IB-1))=STR(IB:LN)
!
! ----- Replacing symbols at the right edge by blanks
!
        CALL CLRCH ( STR(LN-(IB-1)+1:) )
!
        RETURN
        END  !#!  CHASHL  #!#
!
! ------------------------------------------------------------------------
!
        SUBROUTINE CHASHR ( STR )
! ************************************************************************
! *                                                                      *
! *   Routine   CHASHR  adjusts string STR at the right edge. Thus,      *
! *   the last symbol of the string STR becomes the symbol which is not  *
! *   a blank or a binary zero. Freed symbols at the left edge are       *
! *   replaced by blanks.                                                *
! *                                                                      *
! *  ###  21-DEC-90      CHASHR    v1.0  (c)  L. Petrov  21-DEC-90  ###  *
! *                                                                      *
! ************************************************************************
        CHARACTER STR*(*)
        INTEGER*4, EXTERNAL :: ILEN
!
        LN=LEN(STR)
        IE=ILEN(STR)
        IF ( IE .EQ. 0  ) RETURN
        IF ( LN .EQ. IE ) RETURN
!
        STR(1+(LN-IE):LN)=STR(1:IE)
        CALL CLRCH ( STR(1:(LN-IE)) )
        RETURN
        END  !#!  CHASHR  #!#
!
! ------------------------------------------------------------------------
!
      FUNCTION SOTID_ATAN_SC ( S, C )
! ************************************************************************
! *                                                                      *
! *   Function ATAN_SC  finds angle in the range [0, pi2) given sine     *
! *   and cose of that angle.                                            *
! *                                                                      *
! *  ###  13-AUG-1998    ATAN_SC   v1.0  (c)  L. Petrov 13-AUG-1998 ###  *
! *                                                                      *
! ************************************************************************
      IMPLICIT    NONE
      REAL*8      SOTID_ATAN_SC, S, C
      REAL*8      PI, PI2, P2I
      PARAMETER ( PI=3.141592653589793D0, PI2=2.D0*PI, P2I=PI/2D0 ) !
      REAL*8      EPS
      PARAMETER ( EPS=1.D-30 )
!
      IF ( C .GT. EPS ) THEN
           SOTID_ATAN_SC = DATAN2(S,C)
           IF ( S .LT. 0.0D0 ) SOTID_ATAN_SC = SOTID_ATAN_SC + PI2
         ELSE IF ( C .LT. -EPS ) THEN
           SOTID_ATAN_SC = DATAN2(S,C)
           IF ( S .LT. 0.0D0 ) SOTID_ATAN_SC = SOTID_ATAN_SC + PI2
         ELSE ! -EPS < C < EPS
           SOTID_ATAN_SC = P2I
           IF ( S.LT.0 ) SOTID_ATAN_SC = SOTID_ATAN_SC - PI
      END IF
!
      RETURN
      END  FUNCTION   SOTID_ATAN_SC
!
! ------------------------------------------------------------------------
!
      SUBROUTINE SOTID_RD_TEXT ( FINAM, MBUF, BUF, LBUF, IUER )
! ************************************************************************
! *                                                                      *
! *    Subprogram  SOTID_RD_TEXT  reads text file  FINAM and puts its    *
! *  content in the character array BUF.                                 *
! *                                                                      *
! * ### 30-JUN-1991  SOTID_RD_TEXT  v 7.0 (c) Petrov L. 18-DEC-1996  ### *
! *                                                                      *
! ************************************************************************
      IMPLICIT   NONE
      INTEGER*4  MBUF, LBUF, IUER
      CHARACTER  FINAM*(*), BUF(MBUF)*(*)
      CHARACTER  STR*32, STR1*32
      INTEGER*4  IO, J1, LUN
      INTEGER*4  I_LEN, SOTID_GET_UNIT
      LOGICAL    L_EXIST
!
      IF ( LEN(FINAM) .EQ. 0 ) THEN
           CALL SOTID_ERR_LOG ( 9002, IUER, 'SOTID_RD_TEXT', 'Incorrect '// &
     &         'first argument: length of the string = 0' )
           RETURN
      END IF
!
      IF ( MBUF .LE. 0 ) THEN
           CALL CLRCH ( STR )
           WRITE ( UNIT=STR, FMT='(I6)' ) MBUF
           CALL CHASHL ( STR )
           CALL SOTID_ERR_LOG ( 9004, IUER, 'SOTID_RD_TEXT', 'Incorrect '// &
     &         'second argument: MBUF=<0   MBUF='//STR(1:I_LEN(STR)) )
           RETURN
      END IF
!
      IF ( LEN(FINAM) .EQ. 0 ) THEN
           CALL SOTID_ERR_LOG ( 9006, IUER, 'SOTID_RD_TEXT', 'Incorrect '// &
     &         'third argument: length of the string = 0' )
           RETURN
      END IF
!
      INQUIRE ( FILE=FINAM, EXIST=L_EXIST )
      IF ( .NOT. L_EXIST ) THEN
           CALL SOTID_ERR_LOG ( 9008, IUER, 'SOTID_RD_TEXT', 'File "'// &
     &          FINAM(1:I_LEN(FINAM))//'" not found' )
           RETURN
      END IF
!
      LUN = SOTID_GET_UNIT () ! Get free Fotran I/O unit
      OPEN ( UNIT=LUN, FILE=FINAM, STATUS='OLD', IOSTAT=IO )
      IF ( IO .NE. 0 ) THEN
           CALL CLRCH ( STR )
           WRITE ( UNIT=STR, FMT='(I6)' ) IO
           CALL CHASHL ( STR )
           CALL SOTID_ERR_LOG ( 9010, IUER, 'SOTID_RD_TEXT', 'Error '// &
     &          STR(1:I_LEN(STR))//' during openning file '//FINAM )
           RETURN
      END IF
!
      LBUF=0
      DO 410 J1=1,MBUF
         CALL CLRCH ( BUF(J1) )
         READ ( UNIT=LUN, FMT='(A)', IOSTAT=IO ) BUF(J1)
         IF ( IO .EQ. -1 ) GOTO 810
         IF ( IO .NE.  0 ) THEN
              CALL CLRCH ( STR  )
              WRITE ( UNIT=STR, FMT='(I6)' ) IO
              CALL CHASHL ( STR )
              CALL CLRCH ( STR1 )
              WRITE ( UNIT=STR1, FMT='(I12)' ) J1
              CALL CHASHL ( STR )
              CALL SOTID_ERR_LOG ( 9012, IUER, 'SOTID_RD_TEXT', 'Error '// &
     &             STR(1:I_LEN(STR))//' during reading of the '// &
     &             STR1(1:I_LEN(STR1))//'-th line of the file '// &
     &             FINAM )
              CLOSE ( UNIT=LUN )
              RETURN
         END IF
         LBUF=LBUF+1
  410  CONTINUE
!
      CALL CLRCH ( STR )
      WRITE ( UNIT=STR, FMT='(I12)' ) MBUF
      CALL CHASHL ( STR )
      CALL SOTID_ERR_LOG ( 9014, IUER, 'SOTID_RD_TEXT', 'File '// &
     &     FINAM(1:I_LEN(FINAM))//' has been read not up to the end: its '// &
     &    'lenght exceeded values of parameter MBUF='//STR(1:I_LEN(STR)) )
      CLOSE ( UNIT=LUN )
      RETURN
!
 810  CONTINUE
      CLOSE ( UNIT=LUN )
      IF ( LBUF .EQ. 0 ) THEN
           CALL SOTID_ERR_LOG ( 9016, IUER, 'SOTID_RD_TEXT', 'File '// &
     &          FINAM(1:I_LEN(FINAM))//' appeared to be empty' )
           RETURN
      END IF
!
      CALL SOTID_ERR_LOG ( 0, IUER, ' ', ' ' )
      RETURN
      END  SUBROUTINE  SOTID_RD_TEXT
!
! ------------------------------------------------------------------------
!
      SUBROUTINE SOTID_WR_TEXT ( LBUF, BUF, FINAM, IUER )
! ************************************************************************
! *                                                                      *
! *   Routine  SOTID_WR_TEXT  writes down  the text buffer BUF of LBUF   *
! *   lines in the file FINAM.                                           *
! *                                                                      *
! * ### 30-JAN-1998  SOTID_WR_TEXT  v2.0  (c)  L. Petrov 16-AUG-2001 ### *
! *                                                                      *
! ************************************************************************
      IMPLICIT   NONE 
      INTEGER*4  LBUF, IUER
      CHARACTER  BUF(LBUF)*(*), FINAM*(*), STR*80, STR1*80
      INTEGER*4  IO, J1, LUN
      INTEGER*4, EXTERNAL :: ILEN, I_LEN, SOTID_GET_UNIT
!
! --- Test: whether the file exist?
!
      IF ( ILEN(FINAM) .EQ. 0 ) THEN
           CALL SOTID_ERR_LOG ( 9501, IUER, 'SOTID_WR_TEXT', 'Argument '// &
     &         'FINAM (file name to be opened) contains only blanks or '// &
     &         'binary zeroes' )
           RETURN
      END IF
!
      LUN = SOTID_GET_UNIT () ! Get free Fotran I/O unit
      OPEN ( UNIT=LUN, FILE=FINAM, STATUS='UNKNOWN', IOSTAT=IO )
      IF ( IO .NE. 0 ) THEN
           CALL CLRCH ( STR  )
           WRITE ( UNIT=STR, FMT='(I12)' ) IO
           CALL CHASHL ( STR )
           CALL SOTID_ERR_LOG ( 9504, IUER, 'SOTID_WR_TEXT', 'Error during '// &
     &         'openning file "'//FINAM(1:I_LEN(FINAM))//'". IOSTAT='//STR )
           RETURN
      END IF
!
      DO 410 J1=1,LBUF
         WRITE ( UNIT=LUN, FMT='(A)', IOSTAT=IO ) BUF(J1)(1:I_LEN(BUF(J1)))
         IF ( IO .NE. 0 ) THEN
              CALL CLRCH ( STR  )
              WRITE ( UNIT=STR, FMT='(I6)' ) J1
              CALL CHASHL ( STR )
              CALL CLRCH ( STR1 )
              WRITE ( UNIT=STR1, FMT='(I12)' ) IO
              CALL CHASHL ( STR )
              CALL SOTID_ERR_LOG ( 9505, IUER, 'SOTID_WR_TEXT', 'Error '// &
     &             'during writing '//STR(1:I_LEN(STR))//'-th record in '// &
     &             'the file "'//FINAM(1:I_LEN(FINAM))//'". IOSTAT='//STR1 )
              CLOSE ( UNIT=LUN )
              RETURN
         END IF
 410  CONTINUE 
      CLOSE ( UNIT=LUN )
      CALL SOTID_ERR_LOG ( 0, IUER, ' ', ' ' )
!
      RETURN
      END  SUBROUTINE  SOTID_WR_TEXT  
!
! ------------------------------------------------------------------------
!
      FUNCTION   SOTID_GET_UNIT ()
! ************************************************************************
! *                                                                      *
! *   Function GET_UNIT  returns the Fortran input/output unit which     *
! *   is free (not used now).                                            *
! *                                                                      *
! *  ### 15-SEP-2000    GET_UNIT   v1.0 (c)  L. Petrov  15-SEP-2000 ###  *
! *                                                                      *
! ************************************************************************
      INTEGER*4  SOTID_GET_UNIT, J1
      LOGICAL*4  FLAG
!
      SOTID_GET_UNIT = -1
      DO 410 J1=51,99
         INQUIRE ( UNIT=J1, OPENED=FLAG )
         IF ( .NOT. FLAG ) THEN
              SOTID_GET_UNIT = J1
              RETURN
         END IF
 410  CONTINUE
      RETURN
      END  FUNCTION  SOTID_GET_UNIT
